// Initialize Codemirror

var editors = Array();
var active_editor=false; 
var ew = 0;

// special mode - mark joodb brackets
CodeMirror.defineMode("mustache", function(config, parserConfig) {
  var mustacheOverlay = {
    token: function(stream, state) {
      if (stream.match("{")) {
        while ((ch = stream.next()) != null)
          if (ch == "}") break;
        return "mustache";
      }
      while (stream.next() != null && !stream.match("{", false)) {}
      return null;
    }
  };
  return CodeMirror.overlayParser(CodeMirror.getMode(config, parserConfig.backdrop || "text/html"), mustacheOverlay);
});

window.addEvent('domready', function(){
	ew = $('config-document').getSize().x-100;
	$$('.cmeditor').each(function(el) {
		editors[el.name] = CodeMirror.fromTextArea(el, {
			mode: "mustache",
			lineNumbers: true,
			lineWrapping: true,
			onCursorActivity: function(ed) {
				ed.setLineClass(ed.hlLine, null);
				ed.hlLine = ed.setLineClass(ed.getCursor().line, "activeline");
			},
//			extraKeys: {"F11": toggleFullscreenEditing(), "Esc": toggleFullscreenEditing()},
			onFocus: function(){ active_editor=this },
			onBlur: function(){ active_editor=false }
		});
		editors[el.name].hlLine = editors[el.name].setLineClass(0, "activeline");
	});	
	$$('.CodeMirror-scroll').each(function(el) {
		el.setStyle('width',ew);
	});	
	$$('.CodeMirror').each(function(el) {
		el.setStyle('width',ew);
	});		
});


function toggleFullscreenEditing()
{
	if (!active_editor) return;
	
    var editorDiv = $('.CodeMirror-scroll');
    if (!editorDiv.hasClass('fullscreen')) {
        toggleFullscreenEditing.beforeFullscreen = { height: editorDiv.height(), width: editorDiv.width() }
        editorDiv.addClass('fullscreen');
        editorDiv.height('100%');
        editorDiv.width('100%');
        editor.refresh();
    }
    else {
        editorDiv.removeClass('fullscreen');
        editorDiv.height(toggleFullscreenEditing.beforeFullscreen.height);
        editorDiv.width(toggleFullscreenEditing.beforeFullscreen.width);
        editor.refresh();
    }
}


function jInsertEditorText(text, editor) {
	editors[editor].replaceSelection(text);
}

